require File.expand_path(File.dirname(__FILE__) + '/spec_helper')
require 'amqp'
require "amqp-spec/rspec"

describe NetAtlas::Poller do
  #include EM::SpecHelper
  include AMQP::SpecHelper
    default_options = {:host => "localhost", :user => "guest", :pass => "guest", :vhost => "netatlas"}
    default_timeout = 1
  it "should schedule data sources" do
    amqp do
      poller = NetAtlas::Poller.new
      poller.should_receive(:data_sources).twice.and_return(make_data_sources)
      poller.do_scheduler
#      sleep 1
      poller.queue.size.should == 2
      poller.do_scheduler
      poller.queue.size.should == 2
      done
    end
  end

  it "should poll data sources" do
    amqp do
      poller = NetAtlas::Poller.new(:id => 1)
      poller.should_receive(:data_sources).and_return(make_data_sources)
      poller.do_scheduler
      #poller.should_receive(:poll)
      poller.collector_queue.should_receive(:publish)
      poller.next_poll
      EM.add_timer(3) do
        done
      end
      #res1.value.should be_gt(1)
      #done
    end
  end



  def make_data_sources
    [
      {:id => 1, :ip_address => '127.0.0.1', :plugin => 'HTTP', :step_interval => 10, :port => 80, :arguments => {}},
      {:id => 2, :ip_address => '127.0.0.1', :plugin => 'SNMP', :step_interval => 10}
    ].map {|d| NetAtlas::Resource::DataSource.new(d)}
  end
end
